--  echostate.adb
--     reports current state of echo bit in tty driver for fd 0
--     shows how to read attributes from driver and test a bit

with Ada.Text_IO,
     POSIX.IO,
     POSIX.Terminal_Functions;

use Ada.Text_IO,
    POSIX.IO,
    POSIX.Terminal_Functions;

procedure Echo_State is
   Info : Terminal_Characteristics;
begin
   Info := Get_Terminal_Characteristics (File => POSIX.IO.Standard_Input);

   if Terminal_Modes_Of (Info) (Echo) then
      Put_Line (" echo is on , since its flag is True.");
   else
      Put_Line (" echo is OFF, since its flag is False.");
   end if;
end Echo_State;
