--  listchars.adb
--
--  Purpose: List individually all the characters seen on input.
--   Output: Character and ASCII code, one pair per line.
--    Input: Standard input, until the letter 'Q'.
--    Shows: That buffering/editing exists in the terminal drivers.
--    Usage: ./listchars

with Ada.Characters.Handling,
     Ada.Integer_Text_IO,
     Ada.Text_IO;

use Ada.Characters.Handling,
    Ada.Integer_Text_IO,
    Ada.Text_IO;

procedure List_Characters is
   Count : Natural := 0;
   Char  : Character;
begin
   loop
      Get (Item => Char);
      Count := Count + 1;

      exit when Char = 'Q';

      if Is_ISO_646 (Char) then
         Put (Item => "Character number ");
         Put (Item => Count, Width => 3);
         Put (Item => " is '" & Char & "' code ");
         Put (Item => Character'Pos (Char), Width => 0);
         New_Line;
      else
         Put (Item => "Character number ");
         Put (Item => Count, Width => 3);
         Put_Line (" is outside ASCII.");
      end if;
   end loop;
end List_Characters;
