--  setecho.adb
--     Usage: setecho (y|n)
--     Shows: How to read, change and reset TTY attributes.

with Ada.Command_Line,
     Ada.Text_IO,
     POSIX.IO,
     POSIX.Terminal_Functions;

use Ada.Command_Line,
    Ada.Text_IO,
    POSIX.IO,
    POSIX.Terminal_Functions;

procedure Set_Echo is
   Info  : Terminal_Characteristics;
   Modes : Terminal_Modes_Set;
begin
   if Argument_Count = 1 then
      Info := Get_Terminal_Characteristics (File => POSIX.IO.Standard_Input);

      Modes := Terminal_Modes_Of (Info);
      Modes (Echo) := Argument (1) = "y";

      Define_Terminal_Modes (Characteristics => Info,
                             Modes           => Modes);
      Set_Terminal_Characteristics (File            => POSIX.IO.Standard_Input,
                                    Characteristics => Info);
   end if;
end Set_Echo;
