-- play_again0.adb
--      purpose: ask if user wants another transaction
--       method: ask a question, wait for yes/no answer
--      returns: yes => 0
--               no  => 1
--       better: eliminate need to press return

with
  Ada.Text_IO,
  POSIX.Direct_Character_IO,
  POSIX.Process_Primitives;

use POSIX.Process_Primitives;

procedure Play_Again is
   function Get_Response (Question : in     String) return Exit_Status is
      use POSIX.Direct_Character_IO;
   begin
      Ada.Text_IO.Put (Item => Question & " (y/n)? ");
      loop
         case To_Character (Get) is
            when 'y' | 'Y' =>
               return 0;
            when 'n' | 'N' =>
               return 1;
            when others =>
               null;
         end case;
      end loop;
   end Get_Response;

   Question : constant String := "Do you want another transaction";
begin
   Exit_Process (Status => Get_Response (Question));
end Play_Again;
