with
  Ada.Unchecked_Conversion,
  POSIX.Implementation,
  System;

package body C_Signals is

   function To_int is
      new Ada.Unchecked_Conversion (Source => Signal_Types,
                                    Target => POSIX.C.int);

   subtype sighandler_t is System.Address;
   
   function To_sighandler_t is
      new Ada.Unchecked_Conversion (Source => Signal_Handler,
                                    Target => sighandler_t);
   function To_int is
      new Ada.Unchecked_Conversion (Source => sighandler_t,
                                    Target => POSIX.C.int);

   function signal (signum  : POSIX.C.int;
                    handler : sighandler_t) return sighandler_t;
   pragma Import (C, signal, "signal");

   procedure Attach (Handler : in     Signal_Handler;
                     To      : in     Signal_Types) is
      Result : sighandler_t;
   begin
      Result := signal (signum  => To_int (To),
                        handler => To_sighandler_t (Handler));
      POSIX.Implementation.Check (To_int (Result));
   end Attach;

end C_Signals;
